SystemOrganization addCategory: #'GMF-GraphicModel'!
SystemOrganization addCategory: #'GMF-GraphicModel-Tests'!

TestCase subclass: #GMFGAClassTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel-Tests'!

!GMFGAClassTests methodsFor: 'tests' stamp: 'RostislavNovak 12/17/2013 23:34'!
testInitialize
	| x |
	x := GMFGAClass new.
	self assert: (x linearLayout notNil).
	! !

TestCase subclass: #GMFGADrawableObjectTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel-Tests'!

!GMFGADrawableObjectTests methodsFor: 'tests' stamp: 'RostislavNovak 12/17/2013 22:53'!
testChangeColor
	| e |
	e := GMFGADrawableObject  new.
	self assert: e color == GMFGADrawableObject defaultColor.
	e color: Color white.
	self assert: e color == Color white.
	self deny: e color == GMFGADrawableObject defaultColor.! !

TestCase subclass: #GMFGAElementTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel-Tests'!

!GMFGAElementTests methodsFor: 'tests' stamp: 'RostislavNovak 12/15/2013 20:43'!
testChangeSize
	| e |
	e := GMFGAElement new.
	e width: 20.
	e height: 105.
	self assert: e width == 20.
	self assert: e height == 105.! !

!GMFGAElementTests methodsFor: 'tests' stamp: 'RostislavNovak 12/16/2013 22:08'!
testInitialize
	| e |
	e := GMFGAElement new.
	self assert: e color == GMFGAElement defaultColor.
	self assert: e leftTopPoint = (Point x: 20 y: 20).
	self assert: e width == 150.
	self assert: e height == 70.
	self assert: e middlePoint = (Point x: 95 y: 55).
	self assert: e isSelected = false.! !

!GMFGAElementTests methodsFor: 'tests' stamp: 'RostislavNovak 12/15/2013 21:38'!
testIsIn
	| e p c |
	e := GMFGAElement new.
	p := Point x: 40 y: 100.
	e move: p.
	c := Point x: 65 y: 125.
	self assert: (e isIn: c).
	c := Point x: 10 y: 10.
	self deny: (e isIn: c).
	! !

!GMFGAElementTests methodsFor: 'tests' stamp: 'RostislavNovak 12/15/2013 21:33'!
testMiddlePoint
	| e p m xm|
	e := GMFGAElement new.
	p := Point x: 40 y: 100.
	m := Point x: 115 y: 135.
	xm := e middlePoint.
	e leftTopPoint: p.
	self assert: e middlePoint = m.
	self deny: e middlePoint = xm.
	e width: 10.
	self deny: e middlePoint = m.
	m := Point x: 45 y: 135.
	self assert: e middlePoint = m.
	e height: 10.
	self deny: e middlePoint = m.
	m := Point x: 45 y: 105.
	self assert: e middlePoint = m.! !

!GMFGAElementTests methodsFor: 'tests' stamp: 'RostislavNovak 12/15/2013 21:31'!
testMove
	| e p xp|
	e := GMFGAElement new.
	p := Point x: 40 y: 100.
	xp := e leftTopPoint.
	e move: (Point x: 20 y: 80).
	self assert: e leftTopPoint = p.
	self deny: e leftTopPoint = xp.! !

!GMFGAElementTests methodsFor: 'tests' stamp: 'RostislavNovak 12/15/2013 21:28'!
testPoint
	| e p |
	p := Point x: 150 y: 150.
	e := GMFGAElement point: p.
	self assert: e color == GMFGAElement defaultColor.
	self assert: e leftTopPoint = p.
	self assert: e width == 150.
	self assert: e height == 70.
	self assert: e middlePoint = (Point x: 225 y: 185).! !

TestCase subclass: #GMFGALinearLayoutTests
	instanceVariableNames: 'layout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel-Tests'!

!GMFGALinearLayoutTests methodsFor: 'tests' stamp: 'RostislavNovak 12/17/2013 23:17'!
setUp
	layout := GMFGALinearLayout new.
	! !

!GMFGALinearLayoutTests methodsFor: 'tests' stamp: 'RostislavNovak 12/17/2013 22:17'!
testAddItem
	| x y |
	x := GMFGAElement new.
	layout addItem: x.
	y := layout getItem: 1.
	self assert: x == y.
	layout addItem: GMFGAElement new.
	y := layout getItem: 1.
	self assert: x == y.! !

!GMFGALinearLayoutTests methodsFor: 'tests' stamp: 'RostislavNovak 12/17/2013 22:24'!
testIsEmpty
	| x |
	self assert: layout isEmpty.
	x := GMFGAElement new.
	layout addItem: x.
	self deny: layout isEmpty.
	layout removeItem: x.
	self assert: layout isEmpty.
	! !

!GMFGALinearLayoutTests methodsFor: 'tests' stamp: 'RostislavNovak 12/17/2013 22:23'!
testRemoveItem
	| x |
	layout addItem: GMFGAElement new.
	layout addItem: (GMFGAElement point: (Point x: 20 y: 130 )).
	x := layout getItem: 1.
	layout removeItem: x.
	self deny: (x = (layout getItem: 1)).! !

Object subclass: #DataClass
	instanceVariableNames: 'metaModelClass positionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!DataClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 11/3/2013 13:25'!
mmClass: XmetaModelClass pClass: XpositionClass
	^ super new
		initialize;
		metaModelClass: XmetaModelClass;
		positionClass: XpositionClass;
		yourself! !

!DataClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:27'!
metaModelClass
	^metaModelClass! !

!DataClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:27'!
metaModelClass: xClass
	metaModelClass := xClass.! !

!DataClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:27'!
positionClass
	^positionClass! !

!DataClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:27'!
positionClass: xClass
	positionClass := xClass.! !

Object subclass: #DrawDiagram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!DrawDiagram class methodsFor: 'public' stamp: 'RostislavNovak 12/15/2013 16:49'!
draw: dataModel
	Drawer clear.
	dataModel elements do:[ :d | self drawClass: d ].
	dataModel associations do:[ :d | self drawassociation: d ].! !

!DrawDiagram class methodsFor: 'public' stamp: 'RostislavNovak 12/12/2013 16:21'!
drawClass: xClass
	| x y mmClass pClass |
	"Setup needed variables."
	mmClass := xClass metaModelClass.
	pClass := xClass positionClass.
	x := xClass positionClass leftTopPoint x + 5.
	y := xClass positionClass leftTopPoint y + 5.
	
	"Draw box with name and type"
	Drawer rectangleX: pClass leftTopPoint Y: pClass rightBottomPoint.
	Drawer textString: '<<' , mmClass class name asString , '>>' X: (Point x: x y: y).
	y := y + 25.
	Drawer textString: mmClass name X: (Point x: x y: y).
	y := y + 25.
	
	"Draw variables"
	Drawer lineX: (Point x: x - 5 y: y) Y: (Point x: pClass rightBottomPoint x y: y).
	mmClass attributes
		do: [ :d | 
			Drawer textString: d name , ':' , d dataType , '[' , d quantity asString , ']' X: (Point x: x y: y).
			y := y + 25 ].
	
	"Draw methods"
	Drawer lineX: (Point x: x - 5 y: y) Y: (Point x: pClass rightBottomPoint x y: y).
	mmClass methods
		do: [ :d | 
			Drawer
				textString:
					d name , '(' , (d parameters inject: '' into: [ :str :a | str , a , ',' ]) , ')' , ':' , d returnDataType
				X: (Point x: x y: y).
			y := y + 25 ].
		! !

!DrawDiagram class methodsFor: 'public' stamp: 'RostislavNovak 12/5/2013 21:39'!
drawassociation: xAssociation
	| mmClass pClass |
	mmClass := xAssociation metaModelClass.
	pClass  := xAssociation positionClass.
	pClass lines do:[:l | Drawer lineX: l start Y: l end ].
	Drawer textString: mmClass startQuantity asString X: (Point x: (pClass start x)+15 y: (pClass start y)).
	Drawer textString: mmClass endQuantity asString X: (Point x: (pClass end x)-15 y: (pClass end y)).
	Drawer textString: mmClass name asString X: ( Point x: (pClass middlePoint x) y: (pClass middlePoint y)).
	! !

Object subclass: #Drawer
	instanceVariableNames: ''
	classVariableNames: 'fillColor font lineColor lineWidth scale surface transformX transformY'
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!Drawer commentStamp: '<historical>' prior: 0!
A Drawer is me and I would like to draw.

Class Variables
	fillColor:		<Color>
	lineColor:		<Color>
	lineWidth:		<Integer>
	surface:		<AthensCairoSurface>
	font:			<LogicalFont>

fillColor
	- filling for rectangles

lineColor
	- color of lines for lines and rectangle's edges too

lineStyle
	- style of lines for lines and rectangle's edges too

lineWidth
	- width of lines for lines and rectangle's edges too

surface
	- surface where to draw to

font
	- font to text methods!

!Drawer class methodsFor: 'drawing' stamp: 'RostislavNovak 12/1/2013 22:03'!
clear
	surface drawDuring: [ :canvas | surface clear: Color white ].! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:26'!
fillColor
	"getter of Color for filling"

	^ fillColor! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:51'!
fillColor: xColor
	"setter of Color for fillin"

	fillColor := xColor! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
font
	"getter of font"

	^ font! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/14/2013 00:52'!
font: xFont
	"setter of font"

	font := xFont! !

!Drawer class methodsFor: 'initialization' stamp: 'RostislavNovak 12/1/2013 22:14'!
initialize 

	font := LogicalFont familyName: 'Arial' pointSize: 15.
	fillColor := Color white.
	lineColor := Color black.
	lineWidth := 3.
	transformX := transformY := 0.
	scale = 1.0.! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
lineColor
	"getter of Color for lines"

	^ lineColor! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
lineColor: xColor
	"setter of Color for lines"

	lineColor := xColor! !

!Drawer class methodsFor: 'drawing' stamp: 'RostislavNovak 12/1/2013 22:17'!
lineDashedX: xPoint Y: yPoint dash:anInteger
	"drawing of line X and Y are absolute"

	| path |
	surface
		drawDuring: [ :canvas | 
			| stroke |
			canvas pathTransform translateBy: transformX @ transformY.
			canvas pathTransform scaleBy: scale.
			path := canvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: xPoint;
						lineTo: yPoint
				].
			canvas setShape: path.
			stroke := canvas setStrokePaint: lineColor.
			stroke
				width: lineWidth;
				joinRound;
				capRound;
				dashes: ( Array braceWith:anInteger with: (3/4)*anInteger ) offset: 0.
			canvas draw
		].
	^self! !

!Drawer class methodsFor: 'drawing' stamp: 'RostislavNovak 12/1/2013 22:17'!
lineEndDiamondX: xPoint Y: yPoint len:anInteger
	"drawing of triangle near X by way Y->X and size is defined by lenght on line"
"TO DO - zatim funkce line"
	| path |
	surface
		drawDuring: [ :canvas | 
			canvas pathTransform translateBy: transformX @ transformY.
			canvas pathTransform scaleBy: scale.
			path := canvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: xPoint;
						lineTo: yPoint
				].
			canvas setShape: path.
			(canvas setStrokePaint: lineColor) width: lineWidth ; capRound.
			canvas draw 
		].
	^self! !

!Drawer class methodsFor: 'drawing' stamp: 'RostislavNovak 12/1/2013 22:17'!
lineEndTriangleX: xPoint Y: yPoint len:anInteger
	"drawing of triangle near X by way Y->X and size is defined by lenght on line"
"TO DO - zatim funkce line"
	| path |
	surface
		drawDuring: [ :canvas | 
			canvas pathTransform translateBy: transformX @ transformY.
			canvas pathTransform scaleBy: scale.
			path := canvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: xPoint;
						lineTo: yPoint
				].
			canvas setShape: path.
			(canvas setStrokePaint: lineColor) width: lineWidth ; capRound.
			canvas draw 
		].
	^self! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
lineWidth
	"getter of width for lines"

	^ lineWidth! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
lineWidth: xInteger
	"setter of width for lines"

	lineWidth := xInteger! !

!Drawer class methodsFor: 'drawing' stamp: 'RostislavNovak 12/1/2013 22:16'!
lineX: xPoint Y: yPoint
	"drawing of line X and Y are absolute"

	| path |
	surface
		drawDuring: [ :canvas | 
			canvas pathTransform translateBy: transformX @ transformY.
			canvas pathTransform scaleBy: scale.
			path := canvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: xPoint;
						lineTo: yPoint
				].
			canvas setShape: path.
			(canvas setStrokePaint: lineColor) width: lineWidth ; capRound.
			canvas draw 
		].
	^self! !

!Drawer class methodsFor: 'accessing' stamp: 'RostislavNovak 12/1/2013 22:44'!
moveSurfaceX: xX Y: xY
	transformX := transformX + xX.
	transformY := transformY+xY.! !

!Drawer class methodsFor: 'drawing' stamp: 'RostislavNovak 12/1/2013 23:22'!
rectangleX: xPoint Y: yPoint
	"drawing of rectangle
	uses fillColor for filling
	uses lineColor and lineWidth for edges
	X and Y are absolute"
	
	| path |
	scale ifNil:[scale := 1.0].
	surface
		drawDuring: [ :canvas | 
			canvas pathTransform translateBy: transformX @ transformY.
			canvas pathTransform scaleBy: scale.
			path := canvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: 	xPoint;
						lineToX: xPoint x Y: yPoint y;
						lineTo: 		yPoint;
						lineToX: yPoint x Y: xPoint y;
						close
					].
			canvas setShape: path.
			
			canvas setPaint: fillColor.
			canvas draw.
			
			(canvas setStrokePaint: lineColor) width: lineWidth ; joinRound.
			canvas draw
		].
	^self! !

!Drawer class methodsFor: 'accessing' stamp: 'RostislavNovak 12/1/2013 23:07'!
scale
	^scale! !

!Drawer class methodsFor: 'accessing' stamp: 'RostislavNovak 12/1/2013 22:01'!
setScale: value
	scale := scale * value.! !

!Drawer class methodsFor: 'accessing' stamp: 'RostislavNovak 12/2/2013 00:08'!
shift
	^Point x: transformX y: transformY.! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
surface
	"getter of surface"

	^ surface! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
surface: xSurface
	"setter of surface"

	surface := xSurface! !

!Drawer class methodsFor: 'drawing' stamp: 'RostislavNovak 12/1/2013 23:19'!
textString: aString X: aPoint
	"drawing of text"

	"| font |
	font := LogicalFont familyName: 'Arial' pointSize: 20."

	surface
		drawDuring: [ :canvas | 
			canvas pathTransform
				translateX: aPoint x * scale + transformX
				Y: (aPoint y + font getPreciseAscent) * scale + transformY.
			canvas pathTransform scaleBy: scale.
			canvas
				setFont: font;
				setPaint: lineColor.
			canvas drawString: aString ].
	^ self! !

!Drawer class methodsFor: 'drawing' stamp: 'JiriMertin 11/13/2013 22:27'!
textString: aString X: aPoint maxWidth: anInteger
	"drawing of text into closed area"

	| shortedString |
	
	shortedString := aString.
	[ (font widthOfString: shortedString) > anInteger ] whileTrue: 
		[ shortedString := shortedString copyFrom: 1 to: shortedString size - 1 ]. "uneficient for long strings, TODO maybe later"
	
	^self textString: shortedString X: aPoint.! !

Object subclass: #GMFGADrawableObject
	instanceVariableNames: 'color font'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGADrawableObject commentStamp: '<historical>' prior: 0!
A GMFGADrawableObject is object which define must have methods and how to draw some objects.

Instance Variables
!

!GMFGADrawableObject class methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/16/2013 21:56'!
defaultColor
	^Color black.! !

!GMFGADrawableObject methodsFor: 'accessing' stamp: 'RostislavNovak 12/16/2013 21:55'!
color
	^ color! !

!GMFGADrawableObject methodsFor: 'accessing' stamp: 'RostislavNovak 12/16/2013 21:55'!
color: anObject
	color := anObject! !

!GMFGADrawableObject methodsFor: 'settings' stamp: 'RostislavNovak 12/16/2013 21:55'!
defaultColor
	color := GMFGAElement defaultColor.! !

!GMFGADrawableObject methodsFor: 'redering' stamp: 'RostislavNovak 12/16/2013 21:58'!
drawDashed: aCanvas
	| stroke |
	stroke := aCanvas setStrokePaint: color.
	stroke
		width: 1;
		dashes: (Array braceWith: 10 with: 3 / 4 * 10) offset: 0.! !

!GMFGADrawableObject methodsFor: 'redering' stamp: 'RostislavNovak 12/18/2013 00:30'!
drawLine: aCanvas Point: xPoint Point: yPoint
	| path |
	path := aCanvas
		createPath: [ :builder | 
			builder
				absolute;
				moveTo: xPoint;
				lineTo: yPoint ].
	aCanvas setShape: path.
	aCanvas setShape: path.
	(aCanvas setStrokePaint: color)
		width: 2;
		capRound! !

!GMFGADrawableObject methodsFor: 'redering' stamp: 'RostislavNovak 12/16/2013 21:28'!
drawOn: aCanvas
	^self subclassResponsibility.! !

!GMFGADrawableObject methodsFor: 'redering' stamp: 'RostislavNovak 12/16/2013 21:58'!
drawRectangleCanvas: aCanvas point: xPoint corner: yPoint
	| path |
	path := aCanvas
		createPath: [ :builder | 
			builder
				absolute;
				moveTo: xPoint;
				lineToX: xPoint x Y: yPoint y;
				lineTo: yPoint;
				lineToX: yPoint x Y: xPoint y;
				close ].
	aCanvas setShape: path.
	aCanvas setStrokePaint: color.! !

!GMFGADrawableObject methodsFor: 'redering' stamp: 'RostislavNovak 12/18/2013 00:39'!
drawText: aCanvas point: point text: text
	aCanvas pathTransform
		translateX: point x * 1 + 0
		Y: (point y + font getPreciseAscent) * 1 + 0.
	aCanvas pathTransform scaleBy: 1.
	aCanvas
		setFont: font;
		setPaint: color.
	aCanvas drawString: text.
	aCanvas pathTransform loadIdentity.! !

!GMFGADrawableObject methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/18/2013 00:38'!
initialize 
	color := GMFGADrawableObject defaultColor.
	font := font := LogicalFont familyName: 'Arial' pointSize: 18.! !

GMFGADrawableObject subclass: #GMFGAElement
	instanceVariableNames: 'leftTopPoint height width selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGAElement commentStamp: '<historical>' prior: 0!
A GMFGAElement is main graphic element. It is border of all elements in diagram. Please use sub classes.

Instance Variables
	color:		<Color>
	height:		<Integer>
	leftTopPoint:		<Point>
	width:		<Integer>

color
	- color of element with wich will be drawed element

height
	- height of element

leftTopPoint
	- left top point of element

width
	- width of element
!

GMFGAElement subclass: #GMFGACover
	instanceVariableNames: 'metamodelClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGACover commentStamp: '<historical>' prior: 0!
A GMFGACover is only cover for metamodel class.

Instance Variables
	metamodelClass:		<metaModelClass>

metamodelClass
	- xxxxx
!

GMFGACover subclass: #GMFGAAssociation
	instanceVariableNames: 'leftGAElement rightGAElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGAAssociation class methodsFor: 'instance creation' stamp: 'RostislavNovak 12/18/2013 00:44'!
metamodelClass: mClass leftClass: xClass rightClass: yClass
	^ super new
		initialize;
		leftGAElement: xClass;
		rightGAElement: yClass;
		metamodelClass: mClass;
		yourself! !

!GMFGAAssociation methodsFor: 'rendering' stamp: 'RostislavNovak 12/18/2013 00:22'!
drawOn: aCanvas
	| leftPoint rightPoint |
	leftPoint := leftGAElement middlePoint.
	rightPoint := rightGAElement middlePoint.
	self drawLine: aCanvas Point: leftPoint Point: rightPoint.
	aCanvas draw.
	self drawText: aCanvas point: leftPoint text: metamodelClass startQuantity asString.
	self drawText: aCanvas point: rightPoint text: metamodelClass endQuantity asString.
	self drawText: aCanvas point: self middlePoint text: metamodelClass name asString.
	! !

!GMFGAAssociation methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/18/2013 00:43'!
initialize
	super initialize.! !

!GMFGAAssociation methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 23:38'!
leftGAElement
	^ leftGAElement! !

!GMFGAAssociation methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 23:38'!
leftGAElement: anObject
	leftGAElement := anObject! !

!GMFGAAssociation methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 23:38'!
rightGAElement
	^ rightGAElement! !

!GMFGAAssociation methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 23:38'!
rightGAElement: anObject
	rightGAElement := anObject! !

GMFGAAssociation subclass: #GMFGASubCollectionOf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

GMFGACover subclass: #GMFGAClass
	instanceVariableNames: 'linearLayout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGAClass commentStamp: '<historical>' prior: 0!
A GMFGAClass is graphic representation of class.

Instance Variables
	metamodelClass:		<Object>

metamodelClass
	- xxxxx
!

!GMFGAClass class methodsFor: 'instance creation' stamp: 'RostislavNovak 12/18/2013 00:17'!
metamodelClass: xClass
	^ super new
		initialize;
		metamodelClass: xClass;
		yourself! !

!GMFGAClass class methodsFor: 'instance creation' stamp: 'RostislavNovak 12/17/2013 22:40'!
new
	^ super new
		initialize;
		yourself! !

!GMFGAClass methodsFor: 'rendering' stamp: 'RostislavNovak 12/18/2013 00:50'!
drawOn: aCanvas
	self reset.
	linearLayout width = width ifFalse: [ width := linearLayout width ].
	linearLayout height = height ifFalse: [ height := linearLayout height ].
	self
		drawRectangleCanvas: aCanvas
		point: leftTopPoint
		corner: (Point x: leftTopPoint x + width y: leftTopPoint y + height).
	aCanvas draw.
	linearLayout drawOn: aCanvas.
	selected
		ifTrue: [ 
			super drawOn: aCanvas.
			aCanvas draw ]! !

!GMFGAClass methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/17/2013 23:17'!
initialize
	super initialize.
	linearLayout := GMFGALinearLayout point: (leftTopPoint + 5).! !

!GMFGAClass methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 22:51'!
linearLayout
	^ linearLayout.! !

!GMFGAClass methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 22:37'!
linearLayout: anObject
	linearLayout := anObject! !

!GMFGAClass methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/18/2013 00:10'!
reset
	linearLayout := GMFGALinearLayout point: (leftTopPoint + 5).
	linearLayout addItem: (GMFGAItemText text: metamodelClass name asString).
	linearLayout addItem: (GMFGAItemText text: '<<' , metamodelClass class name asString , '>>' ).
	linearLayout addItem: GMFGAItemLine new.
	metamodelClass attributes do:[ :v | linearLayout addItem: (GMFGAItemText text: v asString)].
	linearLayout addItem: GMFGAItemLine new.
	metamodelClass methods do:[ :v | linearLayout addItem: (GMFGAItemText text: v asString)].! !

!GMFGACover methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/18/2013 00:47'!
initialize 
	super initialize.! !

!GMFGACover methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 23:58'!
metamodelClass
	^ metamodelClass! !

!GMFGACover methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 23:58'!
metamodelClass: anObject
	metamodelClass := anObject! !

!GMFGAElement class methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/15/2013 21:02'!
point: aPoint
	^ super new
		initialize;
		leftTopPoint: aPoint;
		yourself! !

!GMFGAElement methodsFor: 'rendering' stamp: 'RostislavNovak 12/17/2013 22:42'!
drawOn: aCanvas
	self drawRectangleCanvas: aCanvas point: leftTopPoint-4  corner: (Point x: leftTopPoint x + width y: leftTopPoint y + height)+4.
	self drawDashed: aCanvas.
	aCanvas draw! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/15/2013 20:46'!
height
	^ height! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/15/2013 20:46'!
height: anObject
	height := anObject! !

!GMFGAElement methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/18/2013 00:47'!
initialize
	super initialize.
	color := GMFGAElement defaultColor.
	leftTopPoint  := Point x: 20 y: 20.
	width := 150.
	height := 70.
	selected := false.! !

!GMFGAElement methodsFor: 'testing' stamp: 'RostislavNovak 12/15/2013 21:36'!
isIn: aPoint 
	| rec |
	rec := Rectangle origin: leftTopPoint corner: (Point x: (leftTopPoint x + width) y: (leftTopPoint y + height)).
	^rec containsPoint: aPoint.
	! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/16/2013 22:07'!
isSelected
	^ selected! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/15/2013 20:46'!
leftTopPoint
	^ leftTopPoint! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/15/2013 20:46'!
leftTopPoint: anObject
	leftTopPoint := anObject! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/15/2013 21:27'!
middlePoint
	^(Point x: leftTopPoint x + (width/2) y: leftTopPoint y + (height/2)).! !

!GMFGAElement methodsFor: 'settings' stamp: 'RostislavNovak 12/15/2013 20:56'!
move: aPoint
	leftTopPoint := leftTopPoint + aPoint.! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/16/2013 22:06'!
selected: anObject
	selected := anObject! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/15/2013 20:46'!
width
	^ width! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/15/2013 20:46'!
width: anObject
	width := anObject! !

GMFGAElement subclass: #GMFGALinearLayout
	instanceVariableNames: 'items skip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGALinearLayout commentStamp: '<historical>' prior: 0!
A GMFGALinearLayout is layout for class items like text.

Instance Variables
	items:		<OrderedCollection >

items
	- collection of items.
!

!GMFGALinearLayout methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 00:49'!
addItem: xObject
	items addLast: xObject.
	xObject isLine
		ifFalse: [ 
			xObject size > width
				ifTrue: [ width := xObject size + 10 ] ].
	height := height + 30.! !

!GMFGALinearLayout methodsFor: 'rendering' stamp: 'RostislavNovak 12/17/2013 23:20'!
drawOn: aCanvas
	| point |
	point := leftTopPoint.
	items
		do: [ :i | 
			i isLine
				ifTrue: [ i drawOn: aCanvas point: point width: width ]
				ifFalse: [ 
					i drawOn: aCanvas point: point.
					point := Point x: point x y: point y + skip ] ]! !

!GMFGALinearLayout methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 22:17'!
getItem: xAt
	^items at: xAt.! !

!GMFGALinearLayout methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/18/2013 00:53'!
initialize
	super initialize.
	items := OrderedCollection new.
	skip := 30.
	height := -30.! !

!GMFGALinearLayout methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 22:20'!
isEmpty
	^items isEmpty.! !

!GMFGALinearLayout methodsFor: 'accessing' stamp: 'RostislavNovak 12/16/2013 23:16'!
items
	^items copy.! !

!GMFGALinearLayout methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 00:52'!
removeItem: xObject
	items remove: xObject.
	height := height - 30.! !

!GMFGALinearLayout methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 00:48'!
size
	^items size.! !

GMFGADrawableObject subclass: #GMFGAItemLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGAItemLine commentStamp: '<historical>' prior: 0!
A GMFGAItemLine is item for linear layout.

Instance Variables
!

!GMFGAItemLine methodsFor: 'redering' stamp: 'RostislavNovak 12/18/2013 00:31'!
drawOn: aCanvas point: point width: width
	self drawLine: aCanvas Point: point - (4@0) Point: (Point x: point x - 7  + width y: point y).
	aCanvas draw! !

!GMFGAItemLine methodsFor: 'redering' stamp: 'RostislavNovak 12/17/2013 23:18'!
isLine
	^true! !

GMFGADrawableObject subclass: #GMFGAItemText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGAItemText commentStamp: '<historical>' prior: 0!
A GMFGAItemText is text in linear layout.

Instance Variables
	text:		<String>

text
	- which will be drawed or holded in class.
!

!GMFGAItemText class methodsFor: 'instance creation' stamp: 'RostislavNovak 12/18/2013 00:38'!
text: string
	^ super new
		initialize;
		text: string;
		yourself! !

!GMFGAItemText methodsFor: 'redering' stamp: 'RostislavNovak 12/17/2013 22:51'!
drawOn: aCanvas point: point
	self drawText: aCanvas point:  point text: text.
! !

!GMFGAItemText methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/18/2013 00:39'!
initialize
	super initialize.! !

!GMFGAItemText methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 23:18'!
isLine
	^false! !

!GMFGAItemText methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 00:35'!
size
	^font widthOfString: text.! !

!GMFGAItemText methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 22:45'!
text
	^ text! !

!GMFGAItemText methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 22:45'!
text: anObject
	text := anObject! !

Object subclass: #PositionClass
	instanceVariableNames: 'leftTopPoint rightBottomPoint middlePoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!PositionClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 11/3/2013 14:03'!
leftTopPoint: xPoint rightBottomPoint: xxPoint
	^ super new
		initialize;
		leftTopPoint: xPoint;
		rightBottomPoint: xxPoint;
		yourself! !

!PositionClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 11/3/2013 13:48'!
new
	^ super new
		initialize;
		yourself! !

!PositionClass methodsFor: 'initialize-release' stamp: 'RostislavNovak 11/14/2013 21:30'!
initialize 
	leftTopPoint := Point x: 15 y: 15.
	rightBottomPoint := Point x: 165 y: 165.
	middlePoint := Point x: 0 y: 0.
	self refreshMiddle.! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovak 12/2/2013 00:01'!
isIn: xPoint
	| rec |
	Transcript show: leftTopPoint.
	Transcript show: '<'.
	Transcript show: xPoint.
	Transcript show: '<'.
	Transcript show: rightBottomPoint; cr.
	rec := Rectangle origin: leftTopPoint  corner: rightBottomPoint.
	^rec containsPoint: xPoint.
	! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:02'!
leftTopPoint
	^ leftTopPoint! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:02'!
leftTopPoint: anObject
	leftTopPoint := anObject! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:02'!
middlePoint
	^ middlePoint! !

!PositionClass methodsFor: 'private' stamp: 'RostislavNovk 11/3/2013 14:02'!
middlePoint: anObject
	middlePoint := anObject! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovak 12/5/2013 21:43'!
move: xPoint
	leftTopPoint := leftTopPoint + xPoint.
	rightBottomPoint := rightBottomPoint  + xPoint.
	self refreshMiddle.! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:39'!
refreshMiddle
	middlePoint := Point x: (leftTopPoint x + rightBottomPoint x) / 2 y: (leftTopPoint y + rightBottomPoint y) / 2! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:02'!
rightBottomPoint
	^ rightBottomPoint! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:02'!
rightBottomPoint: anObject
	rightBottomPoint := anObject! !

PositionClass subclass: #PositionLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

PositionLine subclass: #PositionGroupOfLines
	instanceVariableNames: 'lines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!PositionGroupOfLines class methodsFor: 'instance creation' stamp: 'RostislavNovk 11/3/2013 13:55'!
new 
	^super new initialize; yourself.! !

!PositionGroupOfLines methodsFor: 'initialize-release' stamp: 'RostislavNovk 11/3/2013 13:54'!
initialize
	lines := OrderedCollection new.! !

!PositionGroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:54'!
lines
	^ lines copy.! !

!PositionGroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:36'!
lines: anObject
	lines add: anObject.
	self refreshPosition.! !

!PositionGroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:39'!
refreshPosition
	super leftTopPoint: lines first start.
	super rightBottomPoint: lines last end.
	self refreshMiddle.! !

!PositionLine methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:28'!
end
	^rightBottomPoint! !

!PositionLine methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:28'!
end: anObject
	rightBottomPoint := anObject! !

!PositionLine methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:28'!
start
	^leftTopPoint ! !

!PositionLine methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:28'!
start: anObject
	leftTopPoint := anObject! !
Drawer initialize!
